{
  inputs = {
    nixpkgs.url = "github:nixos/nixpkgs/nixpkgs-unstable";

    flake-parts = {
      url = "github:hercules-ci/flake-parts";
      inputs.nixpkgs-lib.follows = "nixpkgs";
    };
  };

  outputs = {
    self,
    flake-parts,
    ...
  } @ inputs:
    flake-parts.lib.mkFlake {inherit inputs;} {
      systems = ["x86_64-linux" "aarch64-linux" "x86_64-darwin" "aarch64-darwin"];

      perSystem = {
        lib,
        pkgs,
        self',
        ...
      }: {
        devShells.default = with pkgs;
          mkShell {
            packages = [clippy rustfmt rust-analyzer redis xh];
            RUST_SRC_PATH = "${pkgs.rustPlatform.rustLibSrc}";
          };

        formatter = pkgs.alejandra;
      };
    };
}
